# Iron Bank Hardening Manifest

Because contributors cannot generate their own pipelines, contributors will need a [hardening_manifest.yaml](./hardening_manifest.yaml) file in their repository to go through the hardening process. The hardening manifest contains important information such as: the name of the image, build arguments for the container, labels for the container, a list of software dependencies, and the maintainers for the container. This hardening manifest file provides a common format for the tools surrounding the Iron Bank to source relevant information from.

The hardening_manifest.yaml provides details about the container that is built. It also enables contributors to download private artifacts which are not located in the standard dependency systems (e.g. Red Hat Universal Base Image dependencies). The artifacts are acquired and then made available for the Dockerfile when the pipeline is run.  It also allows pulling a different file types (including Docker images and files directly from S3 buckets) so that contributors may, for example, use a multi-stage build approach.

The file should be in the root of the project and should include the following sections.

### name

The `name` section in the hardening_manifest.yaml file is a string which provides the repository name/path that will show up in registry1 for the current container.

### tags

The `tags` section in the hardening_manifest.yaml file provides all the tags the image should be tagged with. The first tag in the list will be the authoritative tag used to reference the image so it should be the most specific tag. The list can contain more broad tags and it should contain the `latest` tag as the last element in the list.

For example ubi8 could be tagged with `8.3` as the authoritative tag, `8` as a broader tag, and `latest` as the most broad tag and the last tag in the list.
```yaml
tags:
- "8.3"
- "8"
- "latest"
```


### args

The `args` section in the hardening_manifest.yaml file provides build arguments to the container build. It contains the `BASE_IMAGE` and `BASE_TAG` arguments along with any other build arguments you wish to provide.

### labels

The `labels` section in the hardening_manifest.yaml file provides the standard OCI labels along with some custom ironbank labels. These are all baked into the image for use on the frontend.

| Label | Description|
|--|--|
| `org.opencontainers.image.title` | Name of the image |
| `org.opencontainers.image.description` | Human-readable description of the software packaged in the image |
| `org.opencontainers.image.licenses` | License(s) under which contained software is distributed |
| `org.opencontainers.image.url` | URL to find more information on the image |
| `org.opencontainers.image.vendor` | Name of the distributing entity, organization or individual |
| `org.opencontainers.image.version` | Authoritative version of the software |
| `mil.dso.ironbank.image.keywords` | Keywords to help with search (ex. "cicd,gitops,golang") |
| `mil.dso.ironbank.image.type` | This value can be "opensource" or "commercial" |
| `mil.dso.ironbank.product.name` | Product the image belongs to for grouping multiple images |


### resources

The `resources` section in the hardening_manifest.yaml file defines all of the dependencies for the container. Each dependency must include:

1. **File URL** - a direct link to the resource being downloaded
1. **Desired file name** - the staging name for the build context (to be referenced by the Dockerfile)
1. **The validation method** - a means to verify that the resource which is being downloaded is in fact the intended resource; supported validation types: `sha256`, `sha512`

For example:

```yaml
resources:
  - url: "https://s3.amazonaws.com/path/to/your/package-1.0.0.tar.gz"
    filename: "package-1.0.0.tar.gz"
    validation:
      type: "sha256"
      value: "3d6b4cfca92067edd5c860c212ff5153d1e162b8791408bc671900309eb555ec" # must be lowercase
```

It is important for contributors to be aware of the way in which the resources included in the hardening_manifest.yaml file can impact the container hardening and approval process.  While there are no restrictions on the types of resources that can be drawn in for use in the Dockerfile build or even on the location where the resources are acquired from, downloading resources from less-than-reputable sources or ones with vulnerabilities can result in the user having to mitigate more findings generated by the scans or risk a container being denied approval.

Currently, basic and aws authentication methods are available to retrieve external resources. x509 authentication will be included in the future as an authentication method. You will need to at least include the SHA checksum associated with the downloaded resource in order to allow for verification within the pipeline.

All contributor credentials/secrets must be submitted directly to Ironbank staff to be added to our pipeline and be made available.  Please contact a member of the Container Hardening team to do so via the Gitlab issue for your application.

**Utilizing hardening_manifest.yaml artifacts in the Dockerfile**

Once the `hardening_manifest.yaml` file has been set up correctly, contributors can utilize the artifacts when performing the build of their Dockerfile.  The pipeline downloads the specified artifact, verifies that the artifact is the same one that the contributor is expecting to be downloaded by comparing the checksum values provided by the contributor and the checksum calculated on the downloaded artifact. The artifact(s) will then be passed to the build stage if the values match.  Otherwise, the pipeline will fail at this stage.

To use a downloaded artifact, add a COPY command to the Dockerfile. The artifact is copied over from the host environment to the container for use in the build.  For example, if the artifact file name you chose was `dependencyX.tar.gz`, you may choose to set this as an argument in the Dockerfile and reference it by a variable name, before copying the artifact to your desired location.  See below:

```Dockerfile
ARG IMPORTANT_DEPENDENCY=dependencyX.tar.gz
COPY ["${IMPORTANT_DEPENDENCY}", "/some/dir"]
RUN tar -zxvf /some/dir/${IMPORTANT_DEPENDENCY}
```

Please see the example Dockerfile, starting in [line 35](../Hardening/Dockerfile.example1#L35) for an additional example.

### maintainers

The `maintainers` section in the hardening_manifest.yaml file provides contact information for the individuals in charge of maintaining the image. It should include the name, email, and gitlab username for all the individuals maintaining the image. There is also a boolean `cht_member` field which should only be present (and marked `true`) if the individual is a member of the container hardening team.

This section will be used to contact contributors in the event of new findings, automatically assign Gitlab issues, bug reports, and more. Please ensure that all members listed in maintainers section are up-to-date.
